#include <vector>
#include <memory>
#include <yaco/grid.hpp>

namespace yaco
{

class Yac2GridDefiner final : public GridVisitor {
  public:
    Yac2GridDefiner()  = default;
    ~Yac2GridDefiner() = default;

    int gridId_ = -1;

    int
    visit(UnstructuredGrid& grid) override;

    int define_mask(std::unique_ptr<yaco::Grid> &grid);

  private:
    std::vector<int> globalIndex_;
    std::vector<int> cellCoreMask_;
    std::vector<int> cellMask_;
};

} // namespace yaco
